//--------------------------------------------------------------------------------------
// File: ccc2.fx
//
// The effect file for the ccc sample.  
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
//--------------------------------------------------------------------------------------


//--------------------------------------------------------------------------------------
// O[oϐ
// Global variables
//--------------------------------------------------------------------------------------

uniform extern float4x4 WorldViewProj : WORLDVIEWPROJECTION;

// ǉ
uniform extern float		g_Len;			// Jƌ_̋

struct SphereVS_Input
{
    float4 Pos      : POSITION;
	float4 Diffuse	: COLOR0;	// _DiffuseF
};

struct SphereVS_Output
{
    float4 Pos		: POSITION;	// _ʒu
	float4 Diffuse	: COLOR0;	// _DiffuseF
};


// xna̕\p O/ʂŐFς
SphereVS_Output SphereVS(	SphereVS_Input Input )
{
    SphereVS_Output Output;

    // _ʒuˉeԂɃgXtH[
	Output.Pos = mul( Input.Pos, WorldViewProj );

	if( Output.Pos.z > g_Len )	// g_Len = J̉sʒu
	{
		Output.Diffuse.r = Input.Diffuse.r * 0.7f;
		Output.Diffuse.g = Input.Diffuse.g * 0.7f;
		Output.Diffuse.b = Input.Diffuse.b * 0.7f;
/*
		Output.Diffuse.r = 1;
		Output.Diffuse.g = 0;
		Output.Diffuse.b = 1;
*/			
	}
	else
	{
		Output.Diffuse = Input.Diffuse;
	}

    return Output;
}

void PixelShader(inout float4 color : COLOR0 )
{
}

//--------------------------------------------------------------------------------------
// Techniques
//--------------------------------------------------------------------------------------
// technique RenderSphere
technique RenderSphere
{
    pass P0
    {          
		vertexShader = compile vs_2_0 SphereVS();
		pixelShader  = compile ps_1_1 PixelShader();
    }
}
